#! /usr/bin/env python3

import sys
import curses
import game
import time

address = sys.argv[2] if len(sys.argv) >= 2 else "localhost:8000"

def to_dec(f, t):
    if t[0] > f[0]:
        return "P"
    elif t[0] < f[0]:
        return "L"
    elif t[1] > f[1]:
        return "D"
    elif t[1] < f[1]:
        return "N"

def find_path(g, c, trpass = False, costs = []):
    p = g.plan
    unv = []
    opens = [c]
    srcs = []
    dists = []
    for x, s in enumerate(p):
        srcs.append([None] * len(s))
        dists.append([200000] * len(s))
        for y, k in enumerate(s):
            unv.append([x, y])
    dists[c[0]][c[1]] = 0
    while unv:
        for delta in [[1, 0], [-1, 0], [0, -1], [0, 1]]:

            ngh = [c[0] + delta[0], c[1] + delta[1]]
            if ngh[0] < 0 or ngh[1] < 0 or ngh[0] >= 10 or ngh[1] >= 10 or p[ngh[0]][ngh[1]] in ["X", "-"] or \
                    (g.enemy and ngh[0] == g.enemy.x and ngh[1] == g.enemy.y):
                    continue

            istrs = isinstance(p[ngh[0]][ngh[1]], int)

            # Distance
            ndist = dists[c[0]][c[1]] + 1

            if ndist < dists[ngh[0]][ngh[1]]:
                if not istrs or trpass:
                    opens.append(ngh)
                dists[ngh[0]][ngh[1]] = ndist
                srcs[ngh[0]][ngh[1]] = c
        #c = opens.pop()
        c = min(unv, key = lambda x: dists[x[0]][x[1]])
        unv.remove(c)
    return (dists, srcs)

log = open("log.txt", "w")
curs = True
try:
    if curs:
        root = curses.initscr()
        curses.curs_set(0)
        curses.noecho()

        curses.start_color()
        curses.use_default_colors()
        curses.init_pair(1, curses.COLOR_GREEN, curses.COLOR_GREEN)
        curses.init_pair(2, curses.COLOR_RED, curses.COLOR_RED)

    g = game.start(address)
    target = None
    while True:
        if curs:
            game.draw_field(g, root)
            root.refresh()

        for x in range(len(g.plan)):
            for y in range(len(g.plan[x])):
                if g.plan[x][y] == "+":
                    break
            if g.plan[x][y] == "+":
                break
        obase = [x, y]

        # Technically, we do not need to recalculate
        dists, srcs = find_path(g, [g.me.x, g.me.y], trpass = True)
        dbase, sbase = find_path(g, obase, trpass = True)
        if (target == None or not isinstance(g.plan[target[0]][target[1]], int)) \
                and g.me.val == 0:


            untrs = []
            trss = []
            for x in range(len(g.plan)):
                for y in range(len(g.plan[x])):
                    if isinstance(g.plan[x][y], int):
                        dist = dists[x][y] + dbase[x][y]
                        untrs.append([[x, y], dist])

            change = True
            # Magic!
            while change:
                change = False
                for tr in untrs:
                    cost = dists[x][y] + dbase[x][y]
                    at = tr[0]
                    while dists[at[0]][at[1]] != 0:
                        at = srcs[at[0]][at[1]]
                        atr = [t for t in untrs if t[0][0] == at[0] and t[0][1] == at[1]]
                        if len(atr) > 0:
                            cost += at[0]
                    if cost != tr[1]:
                        tr[1] = cost
                        change = True

            trss = [[t[0], g.plan[t[0][0]][t[0][1]] / t[1]] for t in untrs if t[1] <= g.me_rem]

            if len(trss) != 0:
                trss.sort(key = lambda x: x[1])
                target = trss[-1][0]
            else:
                target == None

        elif g.me.val != 0:
            dists, srcs = find_path(g, [g.me.x, g.me.y], trpass = True)
            target = [x, y]

        # Backtrack towards us
        if target != None:
            prev = None
            at = target
            while at and dists[at[0]][at[1]] != 0:
                prev = at
                at = srcs[at[0]][at[1]]

            if prev == None or at == None: # No path? Wtf...
                g = game.step(g, "D")
            else:
                g = game.step(g, to_dec(at, prev))
            time.sleep(0.1)
        else:
            # Zzzzz...
            g = game.step(g, "D")

        if not isinstance(g, game.Game):
            break
finally:
    if curs:
        curses.endwin()
    print(g)
