
import requests as req
import curses

class Player():

    def __init__(self, x, y, val, points):
        self.x = x
        self.y = y
        self.val = val
        self.points = points

class Game():

    def __init__(self, addr, gid, rem, plan, me, enemy, total):
        self.addr = addr
        self.gid = gid
        self.rem = rem
        self.me_rem = int(rem / 2) if enemy else rem
        self.plan = plan
        self.me = me
        self.enemy = enemy
        self.total = total

def parse_game(string, addr, old = None):
    plan = []
    for _ in range(10):
        plan.append([None] * 10)
    lines = string.split(b"\r\n")
    gid = int(lines[0])
    rem = int(lines[1])
    for i, li in enumerate(lines[2:12]):
        for k in range(0, 20, 2):
            f = li[k:k + 2]
            if f == b"XX":
                res = "X"
            elif f == b"..":
                res = "."
            elif f == b"++":
                res = "+"
            elif f == b"--":
                res = "-"
            else:
                res = int(f.decode("ascii"))

            plan[int(k / 2)][i] = res

    spl = lines[12].split(b" ")
    me = Player(int(spl[0]) - 1, int(spl[1]) - 1, int(spl[2]), int(spl[3]))
    enemy = None
    if len(lines) >= 14 and lines[13] != b"":
        spl = lines[13].split(b" ")
        enemy = Player(int(spl[0]) - 1, int(spl[1]) - 1, int(spl[2]), int(spl[3]))
    return Game(addr, gid, rem, plan, me, enemy, old.total if old else rem)

def draw_field(g, r):
    totalp = 0
    for x, l in enumerate(g.plan):
        for y, c in enumerate(l):
            if isinstance(c, int):
                totalp += c
                c = "%02d" % c
            else:
                c = str(c) * 2
            r.addstr(y, x * 2, c)

    r.addstr(g.me.y, g.me.x * 2, "++", curses.color_pair(1))
    if g.enemy:
        r.addstr(g.enemy.y, g.enemy.x * 2, "--", curses.color_pair(2))

    # TODO: Add total!!!
    r.addstr(y + 2, 0, "remaining:\t% 4d/%d   " % (g.rem, g.total))
    r.addstr(y + 3, 0, "points:\t\t% 4d/%d   " % (g.me.points, \
            g.me.points + g.me.val + totalp + (g.enemy.points + g.enemy.val if g.enemy else 0)))
    r.addstr(y + 4, 0, "carrying:\t% 4d" % g.me.val)

def start(addr="localhost:8000"):
    data = req.get("http://" + addr + "/start").content
    return parse_game(data, addr)

def step(g, dec):
    data = req.get("http://" + g.addr + "/tah?id=" + str(g.gid) + "&" + "pohyb=" + dec).content
    try:
        return parse_game(data, g.addr, g)
    except:
        return data.decode("ascii")
