#! /usr/bin/env python3

import sys
import curses
import game
import time

address = sys.argv[2] if len(sys.argv) >= 2 else "localhost:8000"

try:
    root = curses.initscr()
    curses.curs_set(0)
    curses.noecho()

    curses.start_color()
    curses.use_default_colors()
    curses.init_pair(1, curses.COLOR_GREEN, curses.COLOR_GREEN)
    curses.init_pair(2, curses.COLOR_RED, curses.COLOR_RED)


    g = game.start(address)
    while True:
        game.draw_field(g, root)
        root.refresh()

        inp = root.getch()
        if inp == ord("w"):
            dec = "N"
            dx = 0
            dy = -1
        elif inp == ord("a"):
            dec = "L"
            dx = -1
            dy = 0
        elif inp == ord("s"):
            dec = "D"
            dx = 0
            dy = 1

        elif inp == ord("d"):
            dec = "P"
            dx = 1
            dy = 0

        try:
            if g.plan[g.me.x + dx][g.me.y + dy] in ["-", "X"] or \
                    (g.me.x == 0 and dx == -1) or (g.me.y == 0 and dy == -1) \
                    or (g.enemy and g.enemy.x == g.me.x + dx and g.enemy.y == g.y + dy):
                raise ValueError()
        except:
            continue

        g = game.step(g, dec)

        if not isinstance(g, game.Game):
            break
finally:
    curses.endwin()
    print(g)

